【POJ 3126 --- Prime Path】筛素数+BFS

【POJ 3126 --- Prime Path】筛素数+BFS

题目来源:点击进入【POJ 3126 — Prime Path】

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

解题思路

首先我们可以先把4位数的所有素数筛选出来,方便后序判断。

然后通过bfs广搜可行方案,并通过dis记录所需次数。

AC代码:

#include <iostream>
#include <algorithm>
#include <cstring>
#include <queue>
using namespace std;
#define SIS std::ios::sync_with_stdio(false),cin.tie(0),cout.tie(0);
#define endl '\n'
const int MAXN = 10005;
bool prime[MAXN],flag;
int m,n,ans,dis[MAXN];

void init()
{
    prime[0]=prime[1]=true;
    for(int i=2;i*i<=MAXN;i++)
    {
        if(!prime[i])
        {
            for(int j=i*i;j<MAXN;j+=i)
                prime[j]=true;
        }
    }
}

void bfs()
{
    memset(dis,-1,sizeof(dis));
    queue<int> q;
    q.push(m);
    dis[m]=0;
    while(!q.empty())
    {
        int x=q.front();
        q.pop();
        int arr[4]={x/1000,x/100%10,x/10%10,x%10};
        for(int i=0;i<4;i++)
        {
            for(int j=0;j<10;j++)
            {
                if(i==0 && j==0) j++;
                if(arr[i]==j) continue;
                int temp=arr[i];
                arr[i]=j;
                int y=arr[0]*1000+arr[1]*100+arr[2]*10+arr[3];
                if(dis[y]==-1 && !prime[y]) q.push(y), dis[y]=dis[x]+1;
                if(y==n) return;
                arr[i]=temp;
            }
        }
    }
}

int main()
{
    SIS;
    init();
    int T;
    cin >> T;
    while(T--)
    {   
        cin >> m >> n;
        bfs();
        if(dis[n]!=-1) cout << dis[n] << endl;
        else cout << "Impossible" << endl;
    }
    return 0;
}
发布了361 篇原创文章 · 获赞 127 · 访问量 3万+

猜你喜欢

转载自blog.csdn.net/qq_41879343/article/details/104011997